#include "JCSVFileReaderObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJCSVFileReaderObj = JCSVFileReaderObj().Register();


void JCSVFileReaderObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "file", file);
}

void JCSVFileReaderObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject* obj_file = getObject( dict, "file");
  if ( obj_file ) file = *(JString*)obj_file;
}

const char* JCSVFileReaderObj::className() const { return "JCSVFileReaderObj";}


JObject* JCSVFileReaderObj::clone() const { return new JCSVFileReaderObj(*this);}


// class constructor
JCSVFileReaderObj::JCSVFileReaderObj() {
  igm = 1 + 1 + 1;
  ogm = 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1;
  on = 0;
  tick = 0;
  numberRecords = 0;
  r0 = r1 = r2 = r3 = r4 = 0;
  r5 = r6 = r7 = r8 = r9 = r10 = 0;
  inStreamAvailable = 0;
}


void JCSVFileReaderObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("CSVreader"), rect);
}


boolean JCSVFileReaderObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JCSVFileReaderObj::inputTag(int n) {
  char* tag[] = {
    "on",
    "tick",
    "numberRecords" };
  return( tag[n] );
}


JString JCSVFileReaderObj::outputTag(int n) {
  char* tag[] = {
    "r0",
    "r1",
    "r2",
    "r3",
    "r4",
    "r5",
    "r6",
    "r7",
    "r8",
    "r9",
    "r10" };
  return( tag[n] );
}


JFRect JCSVFileReaderObj::inputArea(int n) {
  return topArea( n, 0, 1 + 1 + 1, 0.25 );
}


JFRect JCSVFileReaderObj::outputArea(int n) {
  return rightArea(n, 0, 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1);
}


int JCSVFileReaderObj::inputFace(int n) {
  return TOP;
}


int JCSVFileReaderObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JCSVFileReaderObj::inputPoint(int n, JLinkObj& link) {
  return topPoint(n, link, 0, 1 + 1 + 1 );
}


JFPoint JCSVFileReaderObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1);
}


void JCSVFileReaderObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    INT(data) = r0;
  } else if ( n == 1 ) {
    INT(data) = r1;
  } else if ( n == 2 ) {
    INT(data) = r2;
  } else if ( n == 3 ) {
    INT(data) = r3;
  } else if ( n == 4 ) {
    INT(data) = r4;
  } else if ( n == 5 ) {
    INT(data) = r5;
  } else if ( n == 6 ) {
    INT(data) = r6;
  } else if ( n == 7 ) {
    INT(data) = r7;
  } else if ( n == 8 ) {
    INT(data) = r8;
  } else if ( n == 9 ) {
    INT(data) = r9;
  } else if ( n == 10 ) {
    INT(data) = r10;
  }
}

#include <ctype.h>
char* grabInt( char* scanner, int* xresult ) {
	int result = 0;
	if ( scanner == NULL ) {
		return( NULL );
	}
	while ( *scanner ) {
		if ( isdigit( *scanner )) {
			result = result*10 + (*scanner - '0');
		} else {
			scanner++;
			*xresult = result;
			return( scanner );
		}
		scanner++;
	}
	return( NULL );
}

void JCSVFileReaderObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case ON:
    link.access(JIntegerData(on));
	if ( on ) {
		inFile = JFile( file );
		if ( inFile.exists() ) {
			//JComponent::debug( "File exists" );
			inStreamAvailable = 1;
			inputStream = fopen( file, "r" );
		} else {
			//JComponent::debug( "File does not exist" );
			inStreamAvailable = 0;
		}
	} else {
	}
    break;
  case TICK:
    link.access(JIntegerData(tick));
	if ( tick ) {
		if ( inStreamAvailable ) {
			char buf[500];
			if ( fgets( &buf[0], 499, inputStream ) == NULL ) {
				inStreamAvailable = 0;
				fclose( inputStream );
			} else {
				char* scanner = grabInt( &buf[0], &r0 );
				if ( scanner ) broadcast( 0 );
				scanner = grabInt( scanner, &r1 );
				if ( scanner ) broadcast( 1 );
				scanner = grabInt( scanner, &r2 );
				if ( scanner ) broadcast( 2 );
				scanner = grabInt( scanner, &r3 );
				if ( scanner ) broadcast( 3 );
				scanner = grabInt( scanner, &r4 );
				if ( scanner ) broadcast( 4 );
				scanner = grabInt( scanner, &r5 );
				if ( scanner ) broadcast( 5 );
				scanner = grabInt( scanner, &r6 );
				if ( scanner ) broadcast( 6 );
				scanner = grabInt( scanner, &r7 );
				if ( scanner ) broadcast( 7 );
				scanner = grabInt( scanner, &r8 );
				if ( scanner ) broadcast( 8 );
				scanner = grabInt( scanner, &r9 );
				if ( scanner ) broadcast( 9 );
				scanner = grabInt( scanner, &r10 );
				if ( scanner ) broadcast( 10 );
			}

			//JString x;
			//inputStream >> x;
			//JComponent::debug( "test" );
		}
	}
    break;
  case NUMBERRECORDS:
    link.access(JIntegerData(numberRecords));
    break;
  default:
    break;
  }
}


JArray JCSVFileReaderObj::getProperties() {
  JArray properties;
  properties.append(JStringProperty("file", file));
  return properties;
}


boolean JCSVFileReaderObj::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("file")) {
    file = ((JStringProperty*)&prop)->value;
    return true;
  }
  return false;
}


